'Project Cerebrum source code by Madk for Ludum Dare 18

SuperStrict


Framework brl.max2d
Import brl.d3d7max2d
Import brl.pngloader
Import brl.filesystem
Import brl.stream
Import brl.blitz







Import "parse.bmx"

AppTitle = "Project Cerebrum"

Graphics 480, 640
SetBlend ALPHABLEND

AppTitle = "Project Cerebrum"

Global bulletimgpath$ = "media\shot"
Global enemyimgpath$ = "media\enemy"
Global portraitpath$ = "media\portrait"
Global enemyfile$ = "data\enemies.txt"
Global wavedefpath$ = "data\projectcerebrum.txt"
Global gameoverpath$ = "data\gameover.txt"
Global gameover$ = "ERROR: Cerebral link to outside world broken. No sensory devices available. Terminating."


Local fil:TStream = ReadFile("data\definition.txt")
If Not fil RuntimeError "Could not read data\definition.txt"
enemyfile = ReadLine(fil)
wavedefpath = ReadLine(fil)
gameoverpath = ReadLine(fil)
enemyimgpath = ReadLine(fil)
bulletimgpath = ReadLine(fil)
portraitpath = ReadLine(fil)

CloseFile fil
fil = ReadFile(gameoverpath)
If Not fil RuntimeError "Could not read " + gameoverpath
gameover = ReadLine(fil)
CloseFile fil

Global px#, py#, power%

AutoMidHandle True
AutoImageFlags FILTEREDIMAGE

Global player:TImage = LoadImage("media\player.png")

Global logo:TImage = LoadImage("media\logo0ld.png")




Global dialog$[2], speaker% = 0, lastspeech% = MilliSecs()
Global head:TImage[32]
For Local loadhead% = 0 To 31
	head[loadhead] = LoadImage(portraitpath + loadhead + ".png")
Next
If Not head[0] RuntimeError "Could not load portraits"

Global enems:TImage[32]
For Local loadit% = 0 To 31
	enems[loadit] = LoadImage(enemyimgpath + loadit + ".png")
Next
If Not enems[0] RuntimeError "Could not load enemy images"



Global shotimg:TImage[32]
For Local loadit% = 0 To 31
	shotimg[loadit] = LoadImage(bulletimgpath + loadit + ".png")
Next
If Not shotimg[0] RuntimeError "Could not load bullet images"

Global glow0:TImage = LoadImage("media\glow0.png")
Global glow1:TImage = LoadImage("media\glow1.png")
Global glow2:TImage = LoadImage("media\glow2.png")
Global glow3:TImage = LoadImage("media\glow3.png")

Global gear0:TImage = LoadImage("media\gear0.png")
Global gear1:TImage = LoadImage("media\gear1.png")

Global energy0:TImage = LoadImage("media\energy0.png")
Global energy1:TImage = LoadImage("media\energy1.png")

Global text0:TImage = LoadImage("media\text0.png")

Global list:TList = CreateList()
Global mind:TList = CreateList()
Type enem
	Field x#, y#, kind:ekind, hp%, shoot% = 0
	Field tx%, ty%
	Field xv#, yv#, ang# = 360, angv#
	Function add:enem(kind:ekind)
		Local e:enem = New enem
		list.AddLast e
		e.x = Rand(14, GraphicsWidth() - 14)
		If Not kind RuntimeError "Error creating enemy"
		e.y = GraphicsHeight() + ImageHeight(enems[kind.img])
		e.kind = kind
		e.hp = kind.hits
		Return e
	End Function
End Type



Type pup
	Global list:TList = CreateList()
	Field x%, y#
	Function update()
		For Local p:pup = EachIn pup.list
			SetColor 128, 192, 255
			SetScale 1.25,1.25
			DrawImage glow1, p.x, p.y
			SetScale 1, 1
			SetColor 255, 255, 255
			DrawImage energy1, p.x, p.y
			p.y:-1.4
			p.x:+Cos(p.y) - Sin(p.y)
			If Abs(MouseX() - p.x) + Abs(MouseY() - p.y) < 29 Then
				pup.list.Remove p
				part.add p.x, p.y, glow0, 26, .6, 1, 1
				points.add p.x, p.y, 1
				power:+2
				If power > 32 power = 32
			End If
		Next
	End Function
End Type



Global globang# = 0

Type ekind
	Global list:TList = CreateList()
	Field img%
	Field behaviour%
	Field bullet%, damage%, homing%, shotxspeed#, shotyspeed#, xmod%, ymod%, rate%, accurate#
	Field hits%
	Field speed#
	Field rotspeed#
	Field cost%
	Field index%
	
	Method draw(x%, y%, minded%)
		If minded
			SetColor 0, 255, 255
			DrawImage glow0, x, y
			SetColor 255, 255, 255
		EndIf
		If rotspeed <> 0 SetRotation globang * rotspeed
		DrawImage enems[img], x, y
		SetRotation 0
	End Method
	
	Method behave(e:enem, minded%)
		If minded
			Select behaviour
				Case 0, 1
					If Abs(e.x - e.tx) + Abs(e.y - e.ty) < 12 Or (e.tx = 0 And e.ty = 0) Then
						Local ang# = ATan2(e.ty - e.y, e.tx - e.x)
						e.tx = px + (Rand(-150, 150) + Cos(ang) * 90) / 2.0
						e.ty = py + (Rand(-90, 90) + Sin(ang) * 90) / 2.0
						If e.tx < 20 e.tx = 40
						If e.tx > GraphicsWidth() - 20 e.tx = GraphicsWidth() - 40
						If e.ty < 30 e.ty = Rand(24, 140)
					Else
						'DrawRect e.tx - 4, e.ty - 4, 8, 8
						'DrawLine e.x,e.y,e.tx,e.ty
						Local ang# = ATan2(e.ty - e.y, e.tx - e.x)
						e.x:+Cos(ang + Rnd(.4, .9)) * speed * 1.2
						e.y:+Sin(ang + Rnd(.4, .9)) * speed * 0.9
					End If
				Case 2
					Local needang# = ATan2(py - e.y, px - e.x) + 360
					If Abs(e.ang - needang) > 2 Then
						If e.ang > needang e.ang:-1.5
						If e.ang < needang e.ang:+1.5
					EndIf
					e.xv = + Cos(e.ang) * speed + (e.xv / 3.0)
					e.yv = + Sin(e.ang) * speed + (e.yv / 3.0)
					e.x:+e.xv / 2.5
					e.y:+e.yv / 2.5
				Case 3
					If e.y < GraphicsHeight() *.25 Then
						e.y:+speed
					ElseIf e.y > GraphicsHeight() *.32
						e.y:-.084 * speed
					End If
					e.ang:-1.1 * (speed)
					e.x:+(Cos(e.ang) * speed)
					e.y:+(Sin(e.ang) * speed)
					If e.x < 40 e.x:+.5 * speed
					If e.x > GraphicsWidth() - 40 e.x:-.5 * speed
			End Select
		Else
			Select behaviour
				Case 0, 1
					If Abs(e.x - e.tx) + Abs(e.y - e.ty) < 12 Or (e.tx = 0 And e.ty = 0) Then
						If e.tx > 0 e.tx = GraphicsWidth() - e.tx
						If e.tx = 0 e.tx = Rand(26, 100)
						If e.ty > 0 e.ty:+Rand(-67, 67)
						If e.ty = 0 e.ty = GraphicsHeight() - Rand(40, 60)
						If e.ty < 340 e.ty = Rand(340, 400)
						If e.ty > GraphicsHeight() - 60 e.ty = GraphicsHeight() - Rand(40, 120)
						Shoot(e, Self, px, py, 0)
					Else
						If behaviour = 1 And e.x Mod 60 < 2 Then Shoot(e, Self, px, py, 0)
						'DrawRect e.tx - 4, e.ty - 4, 8, 8
						'DrawLine e.x, e.y, e.tx, e.ty
						Local ang# = ATan2(e.ty - e.y, e.tx - e.x)
						e.x:+Cos(ang + Rnd(.4, .9)) * speed * 1.2
						e.y:+Sin(ang + Rnd(.4, .9)) * speed * 0.9
					End If
				Case 3
					If e.y > GraphicsHeight() *.75 Then
						e.y:-speed
					End If
					e.ang:+1.1 * (speed)
					e.x:+(Cos(e.ang) * speed)
					e.y:+(Sin(e.ang) * speed)
					Local tx%, ty%
					Local get% = Rand(0, mind.Count() - 1), target:enem
					For Local e:enem = EachIn mind
						If get = 0 Then target = e;Exit
						get:-1
					Next
					If target
						tx = target.x + Rand(-18, 18)
						ty = target.y + Rand(-18, 18)
					Else
						tx = px;ty = py
					EndIf
					If e.x < 40 e.x:+.5 * speed
					If e.x > GraphicsWidth() - 40 e.x:-.5 * speed
					If e.ang Mod 50 < 1.2 Then Shoot(e, Self, tx, ty, 0)
				Case 4
					If e.y > GraphicsHeight() - 100 Then
						e.y:-speed
						e.ang = Rand(0, 1)
						If e.ang = 0 e.ang = -1
					Else
						If e.y > GraphicsHeight() - 170 And e.yv = 0 Then e.y:-speed / 1.5
						If e.y <= GraphicsHeight() - 168 Then e.yv = 1
						If e.ang = -1 e.x:+speed * 2
						If e.ang = 1 e.x:-speed * 2
						If e.x < 50 e.ang = -1
						If e.x > GraphicsWidth() - 50 e.ang = 1
						If e.yv = 1 Then e.y:+(Sin(e.x)) * e.ang
						Local tx%, ty%
						Local get% = Rand(0, mind.Count() - 1), target:enem
						For Local e:enem = EachIn mind
							If get = 0 Then target = e;Exit
							get:-1
						Next
						If target And Rand(0, 2) > 0 Then
							tx = target.x + Rand(-18, 18)
							ty = target.y + Rand(-18, 18)
						Else
							tx = px;ty = py
						EndIf
						If e.x < 40 e.x:+.5 * speed
						If e.x > GraphicsWidth() - 40 e.x:-.5 * speed
						If e.x Mod 45 < speed * 1.98 Then
							Shoot(e, Self, tx, ty, 0)
						ElseIf e.x Mod 72 < speed * 1.98 Then
							Shoot(e, Self, px, py, 0)
						EndIf
					End If
			End Select
		End If
		
	End Method
End Type


Function Shoot(origin:enem, kind:ekind, tox%, toy%, frommind%)
	Local s:shot = New shot
	shots.addlast s
	Local ang# = ATan2(toy - origin.y, tox - origin.x) + Rnd(-kind.accurate, kind.accurate)
	s.x = origin.x + kind.xmod
	s.y = origin.y + kind.ymod
	s.ang = ang
	s.kind = kind
	s.minded = frommind
	s.parent = origin
End Function


Global shots:TList = CreateList()
Type shot
	Field x%, y%, ang%, kind:ekind, minded%, parent:enem
	Function update()
		For Local s:shot = EachIn shots
			SetRotation s.ang
			DrawImage shotimg[s.kind.bullet], s.x, s.y
			s.x:+Cos(s.ang) * s.kind.shotxspeed
			s.y:+Sin(s.ang) * s.kind.shotyspeed
			Local xlist:TList
			If s.minded xlist = list Else xlist = mind
			For Local e:enem = EachIn xlist
				If ((e.x - s.x) ^ 2 + (e.y - s.y) ^ 2) ^.5 < (ImageWidth(enems[e.kind.img]) + ImageHeight(enems[e.kind.img])) / 2.5 And e <> s.parent Then
					e.hp:-s.kind.damage
					shots.Remove s
					part.add s.x + Cos(s.ang) * 20, s.y + Sin(s.ang) * 20, glow2, 10 * s.kind.damage, .29, 1, 0
				End If
			Next
		Next
		SetRotation 0
	End Function
End Type


Type part
	Global list:TList = CreateList()
	Field img:TImage
	Field x%, y%, time%, tmax%, grow%, fade%, scale# = 1
	Function update()
		For Local p:part = EachIn part.list
			If p.fade SetAlpha 1 / Float (p.tmax - p.time) Else SetAlpha 1
			If p.grow SetScale (p.tmax - p.time) / 2.0 * p.scale, (p.tmax - p.time) / 2.0 * p.scale Else SetScale p.scale, p.scale
			DrawImage p.img, p.x, p.y
			p.time:-1
			If p.time <= 0 part.list.Remove p
		Next
		SetAlpha 1
		SetScale 1, 1
	End Function
	Function add(x%, y%, img:TImage, time%, scale# = 1, fade% = 1, grow% = 0)
		Local p:part = New part
		part.list.AddLast p
		p.x = x;p.y = y
		p.img = img
		p.time = time
		p.tmax = time
		p.grow = grow
		p.fade = fade
		p.scale = scale
	End Function
End Type




Global initship:ekind
Function initkinds()
	Local fil:TStream = ReadFile(enemyfile)
	If Not fil RuntimeError "Could not read " + enemyfile
	Local this:ekind
	Local line% = 0
	Repeat
		line:+1
		Local lin$ = Lower(Trim(Replace(ReadLine(fil), Chr(9), " ")))
		Local cmd$ = Parse(lin, "in " + enemyfile + " on line " + line)
		If cmd = "define"
			this:ekind = New ekind
			this.index = Int(param[0])
			ekind.list.AddLast this
		EndIf
		If cmd = "setinitship" And this
			initship = this
		End If
		If this
			this.behaviour = Int(ReadValue(lin, "behaviour", this.behaviour))
			this.img = Int(ReadValue(lin, "image", this.img))
			this.bullet = Int(ReadValue(lin, "bullet", this.bullet))
			this.damage = Int(ReadValue(lin, "damage", this.damage))
			this.homing = Int(ReadValue(lin, "homing", this.homing))
			this.shotxspeed = Float(ReadValue(lin, "shotxspeed", this.shotxspeed))
			this.shotyspeed = Float(ReadValue(lin, "shotyspeed", this.shotyspeed))
			this.hits = Int(ReadValue(lin, "hits", this.hits))
			this.speed = Float(ReadValue(lin, "speed", this.speed))
			this.xmod = Int(ReadValue(lin, "xmod", this.xmod))
			this.ymod = Int(ReadValue(lin, "ymod", this.ymod))
			this.rate = Int(ReadValue(lin, "rate", this.rate))
			this.accurate = Float(ReadValue(lin, "accurate", this.accurate))
			this.rotspeed = Float(ReadValue(lin, "rotspeed", this.rotspeed))
			this.cost = Int(ReadValue(lin, "cost", this.cost))
		End If
	Until Eof(fil)
	CloseFile fil
End Function



Type points
	Global list:TList = CreateList()
	Field x#, y#, xv#, yv#
	Function add(x%, y%, num%)
		If num = 1
			Local p:points = New points
			p.x = x;p.y = y
			points.list.AddLast p
		Else
			num:+1
			For Local nuu% = 1 To num - 1
				Local p:points = New points
				p.x = x;p.y = y
				p.xv = Cos(((nuu - 1) / Float(num - 1) * 360)) * 0.4234
				p.yv = Sin(((nuu - 1) / Float(num - 1) * 360)) * 0.4234
				points.list.AddLast p
			Next
		End If
	End Function
	Function update()
		SetAlpha.4
		For Local p:points = EachIn points.list
			DrawImage glow3, p.x, p.y
			p.x:+p.xv
			p.y:+p.yv
			Local dist# = ((px - p.x) ^ 2 + (py - p.y) ^ 2) ^.5
			Local keydist% = 240
			If dist < keydist Then
				Local ang# = ATan2(py - p.y, px - p.x)
				p.xv:+Cos(ang) * 4.2 * (1 - dist / Float(keydist))
				p.yv:+Sin(ang) * 4.2 * (1 - dist / Float(keydist))
			End If
			If px < p.x p.xv:-.01
			If px > p.x p.xv:+.01
			If py < p.y p.yv:-.01
			If py > p.y p.yv:+.01
			If Abs(px - p.x) + Abs(py - p.y) < 41 And power < 32 Then
				points.list.Remove p
				power:+1
				part.add p.x, p.y, glow1, 24, 1.2, 1, 0
			EndIf
		Next
		SetAlpha 1
	End Function
End Type


Function splode(x%, y%, size%)
	part.add x, y, glow2, 89, .124 * size, 1, 1
	Local num% = Rand(4, 8)
	For Local small% = 0 To num
		Local ang# = Rand(0, 359), rad# = Rnd(2.4, size * 4.2)
		part.add x + Cos(ang) * rad, y + Sin(ang) * rad, glow2, 100, .025 * size, 1, 0
	Next
End Function


Global gamestart%


Global hpret% = 0

Global pxstate%

Global allies%

Global winning% = 0, wintime% = 0

Global deathdelay% = 0

Global bgang#, sidey#
Global eglow% = 0, glowtime% = 120
Global introtime%
Function mainloop()
	winning = 0
	deathdelay = 0
	px = GraphicsWidth() / 2
	py = 64
	pxstate = Rand(0, 1)
	power = 32
	gamestart = MilliSecs()
	ClearList wave.wlist
	readwave wavedefpath
	bgang = Rand(0, 359)
	sidey = Rand(0, 319)
	globang = 0
	eglow = glowtime
	hpret = 0
	allies = 0
	ClearList mind
	ClearList list
	ClearList part.list
	ClearList points.list
	ClearList pup.list
	ClearList shots
	Local initenem:enem = enem.add(initship)
	initenem.x = Rand(60, GraphicsWidth() - 60)
	initenem.y = Rand(100, 220)
	list.Remove initenem
	mind.AddLast initenem
	allies:+1
	introtime = 400
	Repeat
		globang:+1;hpret:+1
		SetColor 0, 0, 0
		SetAlpha 0.5
		DrawRect 0, 0, GraphicsWidth(), GraphicsHeight()
		SetColor 255, 255, 255
		SetAlpha 0.4
		SetRotation bgang
		DrawImage gear0, GraphicsWidth() - 200, GraphicsHeight() - 280
		bgang:-.32951687
		SetScale 1, 1
		SetRotation 0
		DrawImage gear1, 0, sidey - 320 * 1
		DrawImage gear1, 0, sidey
		DrawImage gear1, 0, sidey + 320 * 1
		DrawImage gear1, 0, sidey + 320 * 2
		sidey:+1.5
		sidey = sidey Mod 320
		SetAlpha 1
		
		

		
		
		part.update
		
		'PLAYER
			'draw player
			Local aim# = ATan2(MouseY() - py, MouseX() - px)
			SetRotation aim - 90
			DrawImage player, px, py
			SetRotation 0
			'move
			Local angmod# = (px - 20) / Float(GraphicsWidth() - 40) * 360
			If pxstate = 0 px:-1;py:+Sin(angmod) *.6
			If pxstate = 1 px:+1;py:+Sin(angmod) *.6
			If px < 20 pxstate = 1
			If px > GraphicsWidth() - 20 pxstate = 0
			
			'Local v:vec = New vec
			'v.x = px;v.y = py
			'vec.list.addlast v
			'For Local v:vec = EachIn vec.list
			'	DrawRect v.x - 4, v.y - 4, 8, 8
			'Next
			
		'MIND ENEMIES
			For Local e:enem = EachIn mind
				e.kind.draw e.x, e.y, 1
				If hpret Mod 75 = 0 e.hp:+1
				If e.hp > e.kind.hits e.hp = e.kind.hits
				If mousein(e.x, e.y, enems[e.kind.img]) And MouseDown(3) And e.kind.img <> 2 Then
					mind.Remove e
					list.AddLast e
					Local bonus% = e.kind.cost * (e.hp / Float(e.kind.hits)) / 1.25
					If bonus < 1 bonus = 1
					points.add e.x, e.y, bonus
					allies:-1
				End If
				e.kind.behave e, 1
				If e.Shoot <= 0
					If MouseDown(1)
						e.Shoot = e.kind.rate
						Shoot e, e.kind, MouseX(), MouseY(), 1
						part.add e.x, e.y, glow0, 16, 1.5, 1, 1
					End If
				Else
					e.Shoot:-1
				End If
				If e.hp <= 0 mind.remove e;splode e.x, e.y, e.kind.hits;allies:-1;points.add e.x, e.y, 1
			Next
		'HOSTILE ENEMIES
			For Local e:enem = EachIn list
				e.kind.draw e.x, e.y, 0
				If mousein(e.x, e.y, enems[e.kind.img]) And MouseDown(2) And power >= e.kind.cost Then
					power:-e.kind.cost
					allies:+1
					list.Remove e
					mind.AddLast e
					part.add e.x, e.y, glow0, 26, 1.2, 1, 0
					Local line# = ATan2(e.y - py, e.x - px) + 180
					Local num% = ((e.x - px) ^ 2 + (e.y - py) ^ 2) ^.5 / 32.0
					For Local parts% = 0 To num - 1
						part.add e.x + Cos(line) * 32 * parts, e.y + Sin(line) * 32 * parts, glow0, 40, 1.5 - parts *.0718, 1, 0
					Next
				End If
				e.kind.behave e, 0
				If e.hp <= 0 list.remove e;splode e.x, e.y, e.kind.hits
			Next

		
		points.update
		pup.update
		shot.update
		
		If eglow > 0
			SetColor 255 - eglow, 255, 255
			eglow:-2
		End If
		SetAlpha 0.67
		For Local gy% = 0 To power - 1
			DrawImage energy0, 98 + gy * 12, 19
		Next
		SetColor 60, 60, 60
		For Local gy% = power To 31
			DrawImage energy0, 98 + gy * 12, 19
		Next
		SetAlpha 1
		SetColor 255, 255, 255
		DrawImage text0, 45, 18
		
		
		wave.update
		
		updatetext
		
		
		If allies < 1 Then
			deathdelay:+1
			SetAlpha deathdelay / 120.0
			SetColor 0, 0, 0
			DrawRect 0, 0, GraphicsWidth(), GraphicsHeight()
			SetColor 255, 255, 255
		Else
			deathdelay = 0
		End If
		
		If deathdelay >= 120 Then
			EndGraphics
			Notify gameover, 1
			End
		End If
		
		If winning And deathdelay = 0
			wintime:+1
			SetAlpha wintime / 420.0
			SetColor 0, 0, 0
			DrawRect 0, 0, GraphicsWidth(), GraphicsHeight()
			SetColor 255, 255, 255
		End If
		If wintime >= 420 Then
			EndGraphics
			End
		End If
		
		
		If introtime > 0
			introtime:-1
			If introtime < 150
				SetAlpha introtime / 150.0
			End If
			SetColor 0, 0, 0
			DrawRect 0,520-80,GraphicsWidth(),160
			SetColor 255, 255, 255
			DrawImage logo, GraphicsWidth() / 2, 520
			SetAlpha 1
		End If
		
		If AppTerminate() End
		Flip
	Forever
End Function


Function mousein%(x%, y%, img:TImage)
	If MouseX() > x - ImageWidth(img) / 2 And MouseX() < x + ImageWidth(img) / 2 And MouseY() > y - ImageHeight(img) / 2 And MouseY() < y + ImageHeight(img) / 2 Then Return 1
End Function


Function readwave(path$)
	Local fil:TStream = ReadFile(path)
	If Not fil RuntimeError "bad file path " + path
	Local w:wave
	Repeat
		Local lin$ = Lower(Trim(Replace(ReadLine(fil), Chr(9), " ")))
		If lin = "w" And w Then
			w.wait = 1
		ElseIf lin = "x" And w Then
			w.waitafter = 1
		Else
			If Left(lin, 2) <> "//" And Len(lin) >= 5
				Local mins$, secs$, hund$, num$, on%
				For Local x% = 1 To Len(lin)
					Local c$ = Mid(lin, x, 1)
					If c = ":"
						on:+1
					ElseIf Instr("012345678ped", c)
						If on = 0 mins:+c
						If on = 1 secs:+c
						If on = 2 hund:+c
						If on = 3 num:+c
					End If
				Next
				w:wave = New wave
				wave.wlist.AddLast w
				If num = "pp"
					w.ispup = 1
				ElseIf num = "ee"
					w.iswin = 1
				ElseIf num = "dd"
					w.char = Int(ReadLine(fil))
					w.text[0] = ReadLine(fil)
					w.text[1] = ReadLine(fil)
				ElseIf num = "ii"
					w.text[0] = ReadLine(fil)
					w.isinclude = 1
				Else
					Local fetch:ekind
					For Local get:ekind = EachIn ekind.list
						If get.index = Int(num) Then fetch = get;Exit
					Next
					If Not fetch Then RuntimeError "Invalid enemy index " + num
					w.kind = fetch
				EndIf
				w.time = Int(hund) * 10 + Int(secs) * 1000 + Int(mins) * 60000
			EndIf
		EndIf
	Until Eof(fil)
End Function



Global abox# = 0.8
Global boxfadestate% = 0

Function updatetext()
	If dialog[0] <> ""
		SetAlpha abox
		SetColor 0, 24, 0
		DrawRect 0, 290 - 36, 320, 72
		SetColor 255, 255, 255
		SetAlpha 1
		If boxfadestate = 0 abox:-0.01 Else abox:+0.01
		If abox < 0.4 boxfadestate = 1
		If abox > 0.8 boxfadestate = 0
		DrawImage head[speaker], 4 + 32, 290
		DrawText dialog[0], 76, 275
		DrawText dialog[1], 76, 295
		If MilliSecs() - lastspeech > (Len(dialog[0]) + Len(dialog[1])) * 150 Or KeyDown(KEY_SPACE) Then
			dialog[0] = "";dialog[1] = ""
			If waitfortext Then waitfortext = 0;gamestart = MilliSecs() ;stopaddingwaits = 0
		Else
			FlushKeys
		EndIf
	Else
		abox = 0.8;boxfadestate = 0
	End If
End Function




Global pupwait:pup, waitforpup% = 0
Global enemwait:TList = CreateList(), waitforenem% = 0
Global waitfortext% = 0
Global stopaddingwaits% = 0

Global inactivelist:TList[8], nest% = 0

Type wave
	Global wlist:TList = CreateList()
	Field time%
	Field kind:ekind
	Field ispup%, isinclude%, iswin%
	Field text$[2], char%
	Field wait% = 0, waitafter% = 0
	Function update()
		If waitforpup Then
			If Not pupwait Then waitforpup = 0;gamestart = MilliSecs()
			stopaddingwaits = 0
		End If
		If waitforenem Then
			Local ready% = 1
			For Local k1:enem = EachIn enemwait
				For Local k2:enem = EachIn list
					If k1 = k2 Then ready = 0
				Next
			Next
			If ready Then
				waitforenem = 0
				ClearList enemwait
				gamestart = MilliSecs()
				stopaddingwaits = 0
			End If
		End If
		For Local w:wave = EachIn wave.wlist
			If w.time <= MilliSecs() - gamestart And stopaddingwaits = 0 Then
				If w.ispup And waitfortext = 0 And stopaddingwaits = 0
					wave.wlist.Remove w
					Local p:pup = New pup
					pup.list.AddLast p
					p.y = GraphicsHeight() + 24
					p.x = Rand(60, GraphicsWidth() - 60)
					If w.wait Then
						pupwait = p;waitforpup = 1
						If w.waitafter = 1 stopaddingwaits = 1
					EndIf
				'ElseIf w.isinclude And waitforenem = 0 And waitforpup = 0 And waitfortext = 0 And stopaddingwaits = 0
				'	For Local fix% = 0 To nest
				'	DebugStop
				'		For Local
				'	Next
				ElseIf w.text[0] <> "" Or w.text[1] <> "" And waitforenem = 0 And waitforpup = 0 And waitfortext = 0 And stopaddingwaits = 0
					wave.wlist.Remove w
					dialog[0] = w.text[0] + " "
					dialog[1] = w.text[1]
					speaker = w.char
					lastspeech = MilliSecs()
					If w.wait Then
						waitfortext = 1
						If w.waitafter = 1 stopaddingwaits = 1
					EndIf
				ElseIf w.kind And waitfortext = 0 And stopaddingwaits = 0 And w.text[0] = "" And w.text[1] = "" And w.ispup = 0
					wave.wlist.Remove w
					If Not w.kind RuntimeError "Wave referencing nonexistant enemy template"
					Local made:enem = enem.add(w.kind)
					If w.wait Then
						enemwait.addlast made;waitforenem = 1
						If w.waitafter = 1 stopaddingwaits = 1
					EndIf
				ElseIf w.iswin = 1 And waitforenem = 0 And waitforpup = 0 And waitfortext = 0 And stopaddingwaits = 0
					winning = 1
				EndIf
			Else
				Exit
			End If
		Next
	End Function
End Type









initkinds
mainloop